import { DoCheck, EventEmitter, IterableDiffers, OnChanges, SimpleChange } from '@angular/core';
import { AngularDualListModel } from './angular-dual-listbox.model';
import * as i0 from "@angular/core";
export type compareFunction = (a: any, b: any) => number;
export declare class CmAngularDualListboxComponent implements DoCheck, OnChanges {
    private differs;
    static AVAILABLE_LIST_NAME: string;
    static CONFIRMED_LIST_NAME: string;
    static LTR: string;
    static RTL: string;
    static DEFAULT_FORMAT: {
        add: string;
        remove: string;
        all: string;
        none: string;
        direction: string;
        draggable: boolean;
    };
    id: string;
    key: string;
    display: any;
    height: string;
    filter: boolean;
    format: {
        add: string;
        remove: string;
        all: string;
        none: string;
        direction: string;
        draggable: boolean;
    };
    sort: boolean;
    compare: compareFunction | undefined;
    disabled: boolean;
    source: Array<any>;
    destination: Array<any>;
    destinationChange: EventEmitter<any>;
    available: AngularDualListModel;
    confirmed: AngularDualListModel;
    sourceDiffer: any;
    destinationDiffer: any;
    private sorter;
    constructor(differs: IterableDiffers);
    ngOnChanges(changeRecord: {
        [key: string]: SimpleChange;
    }): void;
    ngDoCheck(): void;
    buildAvailable(source: Array<any>): boolean;
    buildConfirmed(destination: Array<any>): boolean;
    updatedSource(): void;
    updatedDestination(): void;
    direction(): boolean;
    dragEnd(list?: any): boolean;
    drag(event: DragEvent, item: any, list: AngularDualListModel): void;
    allowDrop(event: DragEvent, list: AngularDualListModel): boolean;
    dragLeave(): void;
    drop(event: DragEvent, list: AngularDualListModel): void;
    private trueUp;
    findItemIndex(list: Array<any>, item: any, key?: any): number;
    private makeUnavailable;
    moveItem(source: AngularDualListModel, target: AngularDualListModel, item?: any, trueup?: boolean): void;
    isItemSelected(list: Array<any>, item: any): boolean;
    shiftClick(event: MouseEvent, index: number, source: AngularDualListModel, item: any): void;
    selectItem(list: Array<any>, item: any): void;
    selectAll(source: AngularDualListModel): void;
    selectNone(source: AngularDualListModel): void;
    isAllSelected(source: AngularDualListModel): boolean;
    isAnySelected(source: AngularDualListModel): boolean;
    private unpick;
    clearFilter(source: AngularDualListModel): void;
    onFilter(source: AngularDualListModel): void;
    private makeId;
    protected makeName(item: any, separator?: string): string;
    static ɵfac: i0.ɵɵFactoryDeclaration<CmAngularDualListboxComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<CmAngularDualListboxComponent, "dual-listbox", never, { "id": { "alias": "id"; "required": false; }; "key": { "alias": "key"; "required": false; }; "display": { "alias": "display"; "required": false; }; "height": { "alias": "height"; "required": false; }; "filter": { "alias": "filter"; "required": false; }; "format": { "alias": "format"; "required": false; }; "sort": { "alias": "sort"; "required": false; }; "compare": { "alias": "compare"; "required": false; }; "disabled": { "alias": "disabled"; "required": false; }; "source": { "alias": "source"; "required": false; }; "destination": { "alias": "destination"; "required": false; }; }, { "destinationChange": "destinationChange"; }, never, never, true, never>;
}
